ZOJ3471 MostPowerful 状压DP

同类类于poj3311,但是要简单,不用转什么弯子

直接  十种气体  每种是否存在的状态  s,然后 dp[s]  = max(dp[s],dp[s - {被碰的气体状态}] + 两气体相碰获得的价值);想起来不难,写起来也算比较简单

int n;

int dp[1<<12];

int mp[10 + 5][10 + 5];

void init() {
	memset(mp,0,sizeof(mp));
	memset(dp,0,sizeof(dp));
}

bool input() {
	while(cin>>n,n) {
		for(int i=0;i<n;i++)
			for(int j=0;j<n;j++)
				scanf("%d",&mp[i][j]);
		return false;
	}
	return true;
}

void cal() {
	int ans = 0;
	for(int i=0;i<(1<<n);i++) {
		for(int j=0;j<n;j++) {
			if(!(i&(1<<j)))continue;
			for(int k=0;k<n;k++) {
				if(!(i&(1<<k)))continue;
				if(j == k)continue;
				dp[i] = max(dp[i],dp[i^(1<<j)] + mp[k][j]);
			}
		}
		ans = max(ans,dp[i]);
	}
	cout<<ans<<endl;
}

void output() {

}

int main () {
	while(true) {
		init();
		if(input())return 0;
		cal();
		output();
	}
	return 0;
}

ZOJ3471 MostPowerful 状压DP,布布扣,bubuko.com

时间: 2024-12-28 13:07:18

ZOJ3471 MostPowerful 状压DP的相关文章

zoj3471(状压dp)

题目连接:http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=4257 题意:不超过10种气体,两两之间相互碰撞可以产生一定的能量,如a碰b,那么b气体就消失,自身不能碰自身,问最后所能得到的最大能量. 分析:用10位二进制表示气体是否存在,0表示存在,1表示不存在,s(上一个状态)中的两种气体碰撞并且有一种消失,可以得到新的状态进行状态转移. 转移方程:dp[s|(1<<(j-1))]=max(dp[s|(1<<(

【状压dp】Most Powerful

[ZOJ3471]Most Powerful Time Limit: 2 Seconds      Memory Limit: 65536 KB Recently, researchers on Mars have discovered N powerful atoms. All of them are different. These atoms have some properties. When two of these atoms collide, one of them disappe

ZOJ3305Get Sauce 状压DP,

状压DP的题目留个纪念,首先题意一开始读错了,搞了好久,然后弄好了,觉得DFS可以,最后超时,修改了很久还是超时,没办法看了一下n的范围,然后觉得状压可以,但是没有直接推出来,就记忆化搜索了一下,可是一直错,莫名奇妙,然后没办法看了一下题解,发现了下面这个比较好的方法,然后按照这个方程去推,然后敲,也是WA了好多把,写的太搓了,没人家的清楚明了,唉~也算是给自己留个纪念,状压一直做的都不太好~唉~还好理解了, 参考了  http://blog.csdn.net/nash142857/articl

poj 2411 Mondriaan&#39;s Dream(状压DP)

Mondriaan's Dream Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 12232   Accepted: 7142 Description Squares and rectangles fascinated the famous Dutch painter Piet Mondriaan. One night, after producing the drawings in his 'toilet series

(状压dp)uva 10817 Headmaster&#39;s Headache

题目地址 1 #include <bits/stdc++.h> 2 typedef long long ll; 3 using namespace std; 4 const int MAX=1e5+5; 5 const int INF=1e9; 6 int s,m,n; 7 int cost[125]; 8 //char sta[MAX]; 9 string sta; 10 int able[125]; 11 int dp[125][1<<8][1<<8]; 12 in

HDU5816 Hearthstone(状压DP)

题目 Source http://acm.hdu.edu.cn/showproblem.php?pid=5816 Description Hearthstone is an online collectible card game from Blizzard Entertainment. Strategies and luck are the most important factors in this game. When you suffer a desperate situation an

HDU 4336 容斥原理 || 状压DP

状压DP :F(S)=Sum*F(S)+p(x1)*F(S^(1<<x1))+p(x2)*F(S^(1<<x2))...+1; F(S)表示取状态为S的牌的期望次数,Sum表示什么都不取得概率,p(x1)表示的是取x1的概率,最后要加一因为有又多拿了一次.整理一下就可以了. 1 #include <cstdio> 2 const int Maxn=23; 3 double F[1<<Maxn],p[Maxn]; 4 int n; 5 int main() 6

Travel(HDU 4284状压dp)

题意:给n个城市m条路的网图,pp在城市1有一定的钱,想游览这n个城市(包括1),到达一个城市要一定的花费,可以在城市工作赚钱,但前提有工作证(得到有一定的花费),没工作证不能在该城市工作,但可以走,一个城市只能工作一次,问pp是否能游览n个城市回到城市1. 分析:这个题想到杀怪(Survival(ZOJ 2297状压dp) 那个题,也是钱如果小于0就挂了,最后求剩余的最大钱数,先求出最短路和 Hie with the Pie(POJ 3311状压dp) 送披萨那个题相似. #include <

BZOJ 1087: [SCOI2005]互不侵犯King( 状压dp )

简单的状压dp... dp( x , h , s ) 表示当前第 x 行 , 用了 h 个 king , 当前行的状态为 s . 考虑转移 : dp( x , h , s ) = ∑ dp( x - 1 , h - cnt_1( s ) , s' ) ( s and s' 两行不冲突 , cnt_1( s ) 表示 s 状态用了多少个 king ) 我有各种预处理所以 code 的方程和这有点不一样 ------------------------------------------------